//----------------------------------------------------------------------------
//
// License:  See top level LICENSE.txt file.
//
// Description: Dialog box for simple text data, e.g. position information.
//
//----------------------------------------------------------------------------
// $Id$

#ifndef ossimGuiPolygonRemapperDialog_HEADER
#define ossimGuiPolygonRemapperDialog_HEADER 1

#include <ossim/base/ossimRefPtr.h>
#include <QDialog>
#include <ossim/imaging/ossimPolyCutter.h>

class ossimDpt;
class ossimDrect;
class QMouseEvent;
class QString;
class QTextEdit;

namespace ossimGui
{
   class ImageScrollView;
   
   class PolygonRemapperDialog : public QDialog
   {
   Q_OBJECT

   public:
      
      /** @brief default constructor */
      PolygonRemapperDialog( QWidget* parent=0, Qt::WFlags f = 0 );

      void setWidget( ossimGui::ImageScrollView* widget );
      void setPolyCutter( ossimPolyCutter* polygon );
      
      enum Mode
      {
         UNKNOWN,
         ACCEPTING_POINTS
      };

   public slots:

      void track( const ossimDpt& scenePt );
      void mousePress(QMouseEvent* e, const ossimDpt& scenePoint);
      void getPolyPoint();
      
   protected:

   private:
      void fireRefreshEvent();
      void sceneToImage( const ossimDpt& scenePt, ossimDpt& imagePt ) const;

      QTextEdit*                 m_textEdit;
      ossimGui::ImageScrollView* m_widget;
      ossimRefPtr<ossimPolyCutter> m_polyCutter;
      QPushButton*               m_addPolygon;
      
      std::vector<ossimDpt> m_polygon;
      Mode m_mode;
   };
}

#endif /* #ifndef ossimGuiPolygonRemapperDialog_HEADER */
